// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from nao_sensor_msgs:msg/JointStatuses.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_STATUSES__FUNCTIONS_H_
#define NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_STATUSES__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "nao_sensor_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "nao_sensor_msgs/msg/detail/joint_statuses__struct.h"

/// Initialize msg/JointStatuses message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * nao_sensor_msgs__msg__JointStatuses
 * )) before or use
 * nao_sensor_msgs__msg__JointStatuses__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
bool
nao_sensor_msgs__msg__JointStatuses__init(nao_sensor_msgs__msg__JointStatuses * msg);

/// Finalize msg/JointStatuses message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
void
nao_sensor_msgs__msg__JointStatuses__fini(nao_sensor_msgs__msg__JointStatuses * msg);

/// Create msg/JointStatuses message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * nao_sensor_msgs__msg__JointStatuses__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
nao_sensor_msgs__msg__JointStatuses *
nao_sensor_msgs__msg__JointStatuses__create();

/// Destroy msg/JointStatuses message.
/**
 * It calls
 * nao_sensor_msgs__msg__JointStatuses__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
void
nao_sensor_msgs__msg__JointStatuses__destroy(nao_sensor_msgs__msg__JointStatuses * msg);


/// Initialize array of msg/JointStatuses messages.
/**
 * It allocates the memory for the number of elements and calls
 * nao_sensor_msgs__msg__JointStatuses__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
bool
nao_sensor_msgs__msg__JointStatuses__Sequence__init(nao_sensor_msgs__msg__JointStatuses__Sequence * array, size_t size);

/// Finalize array of msg/JointStatuses messages.
/**
 * It calls
 * nao_sensor_msgs__msg__JointStatuses__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
void
nao_sensor_msgs__msg__JointStatuses__Sequence__fini(nao_sensor_msgs__msg__JointStatuses__Sequence * array);

/// Create array of msg/JointStatuses messages.
/**
 * It allocates the memory for the array and calls
 * nao_sensor_msgs__msg__JointStatuses__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
nao_sensor_msgs__msg__JointStatuses__Sequence *
nao_sensor_msgs__msg__JointStatuses__Sequence__create(size_t size);

/// Destroy array of msg/JointStatuses messages.
/**
 * It calls
 * nao_sensor_msgs__msg__JointStatuses__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
void
nao_sensor_msgs__msg__JointStatuses__Sequence__destroy(nao_sensor_msgs__msg__JointStatuses__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_STATUSES__FUNCTIONS_H_
